//+------------------------------------------------------------------+
//| Multi_Ind_Closer_v1
//+------------------------------------------------------------------+
#property copyright "Copyright(c)2008 latimeria"

extern string  About = "<<< Multi_Ind_Closer >>>";
extern bool    EnabeleCloser = true ;

// Indicator
extern string  IndicatorExp = "<<< Select Indicator >>>";
extern string  Indicator_note = "1=RSI  2=CCI  3=DeMarker  4=Bears";
extern int     Indicator = 1;

// TimeFrame
extern string  TimeFrameExp = "<<< Time Frame Setting >>>";
extern string  TF_note = "1=M1 2=M5 3=M15 4=M30 5=1H 6=4H 7=D1 8=W1 9=MN 0=Chart";
extern int     TimeFrame = 0;

// Ind_Period
extern string  Ind_PeriodExp = "<<< Select Ind_Period >>>";
extern int     Ind_Period = 14;

// Price
extern string  PriceExp = "<<< Select Applied Price >>>";
extern string  Price_note = "0=Close 1=Open 2=High 3=Low 4=Median 5=Typical 6=Weighted";
extern int     AppliedPrice = 0;

// BarShift
extern string  BarShiftExp = "<<< Select BarShift >>>";
extern string  BarShift_note = "0=CurrentBar 1=Previous(Closed)Bar";
extern int     BarShift = 1;

// Misc Settings
extern string  MiscellaneousExp = "<<< Miscellaneous >>>";
extern bool    ShowInformation = true ;
extern int     Slippage = 5;
extern bool    Alert_On = false ;

string  EANAME = "Multi_Ind_Closer_v1";

int DQ_ADJUST []  = { 0 , 1 , 10 , 100 , 1 , 10 , 100 };
int TF_SELECT []  = { 0 , 1 , 5 , 15 , 30 , 60 , 240 , 1440 , 10080 , 43200 };
string TF_STRING []  = { "Chart","M1","M5","M15","M30","H1","H4","D1","W1","MN" };
string DOW[] = { "Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"};
string PRICE_STRING []  = { "Close","Open","High","Low","Median","Typical","Weighted" };
string IND_NAME []  = { "","RSI","CCI","DeMarker","BearsPower" };

double CenterVal []  = { 0, 50, 0 , 0.5, 0 };

//+------------------------------------------------------------------+
//| init                                                            
//+------------------------------------------------------------------+
int init()
{
   return(0);
}

//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
int start()
{
   if(ShowInformation) ShowStatus();

   if(!EnabeleCloser) return(0);

   int DIGITS = MarketInfo(Symbol(),MODE_DIGITS);
   int DQADJ = DQ_ADJUST [ DIGITS ];

   int SLIP = Slippage * DQADJ;

   bool success;

   for(int i=0; i<OrdersTotal(); i++)
   {
      bool selected = OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if(selected && OrderSymbol() == Symbol())
      {
         switch(OrderType())
         { 
            case OP_BUY: if( CheckIndicator(0) ) // Buy
            {
               success = OrderClose(OrderTicket(),OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), SLIP, CLR_NONE); // close buy orders
               if(success && Alert_On) Alert( EANAME+" closed Buy Position "+OrderSymbol()+" at "+DoubleToStr(OrderClosePrice(),DIGITS) ); 
               if (!success) Print(EANAME+" : Error = " + GetLastError());
            }
            break;
            case OP_SELL: if( CheckIndicator(1) ) // Sell
            {
               success = OrderClose(OrderTicket(),OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), SLIP, CLR_NONE); // close buy orders
               if(success && Alert_On) Alert( EANAME+" closed Sell Position "+OrderSymbol()+" at "+DoubleToStr(OrderClosePrice(),DIGITS) ); 
               if (!success) Print(EANAME+" : Error = " + GetLastError());
            }
            break;
            default: break;
         }
      }
   }

   return(0);
}

//+------------------------------------------------------------------+
//| CheckIndicator
//+------------------------------------------------------------------+
bool CheckIndicator(int TYPE)
{
   bool CloseSignal = false;

   switch(TYPE)
   { 
      case 0: // Buy
      switch(Indicator)
      {
         case 1: if(RSI() < 50) CloseSignal = true; break;
         case 2: if(CCI() < 0) CloseSignal = true; break;
         case 3: if(DeM() < 0.5) CloseSignal = true; break;
         case 4: if(Bears() < 0) CloseSignal = true; break;
         default: break;
      }
      break;

      case 1: // Sell
      switch(Indicator)
      {
         case 1: if(RSI() > 50) CloseSignal = true; break;
         case 2: if(CCI() > 0) CloseSignal = true; break;
         case 3: if(DeM() > 0.5) CloseSignal = true; break;
         case 4: if(Bears() > 0) CloseSignal = true; break;
         default: break;
      }
      break;
   }

   return(CloseSignal);
}

//+------------------------------------------------------------------+
//| RSI
//+------------------------------------------------------------------+
double RSI()
{
   int TF = TF_SELECT [ TimeFrame ];
   if(BarShift<0) BarShift = 0;
   return( iRSI(NULL,TF,Ind_Period, AppliedPrice, BarShift) );
}

//+------------------------------------------------------------------+
//| CCI
//+------------------------------------------------------------------+
double CCI()
{
   int TF = TF_SELECT [ TimeFrame ];
   if(BarShift<0) BarShift = 0;
   return( iCCI(NULL,TF,Ind_Period, AppliedPrice, BarShift) );
}

//+------------------------------------------------------------------+
//| DeM
//+------------------------------------------------------------------+
double DeM()
{
   int TF = TF_SELECT [ TimeFrame ];
   if(BarShift<0) BarShift = 0;
   return( iDeMarker(NULL,TF,Ind_Period,BarShift) );
}

//+------------------------------------------------------------------+
//| Bears
//+------------------------------------------------------------------+
double Bears()
{
   int TF = TF_SELECT [ TimeFrame ];
   if(BarShift<0) BarShift = 0;
   return( iBearsPower(NULL,TF,Ind_Period,AppliedPrice,BarShift) );
}

//+------------------------------------------------------------------+
//| Show Status                                                      |
//+------------------------------------------------------------------+
void ShowStatus()
{
   string DAAAAASH = "------------------------------------";

   string Enabeled = "Close Function = On"; if(!EnabeleCloser) Enabeled = "Close Function = Off";

   string IND = "Indicator = Invalid Setting"; string IND_VAL = "Current Value = ---";
   
   string Close_Val;
   switch(Indicator)
   {
      case 1: IND_VAL = "Current Value = "+DoubleToStr(RSI(),2); IND = "Indicator = "+IND_NAME [ Indicator ]; Close_Val = "Close Value = "+DoubleToStr(CenterVal [ Indicator ],2); break;
      case 2: IND_VAL = "Current Value = "+DoubleToStr(CCI(),2); IND = "Indicator = "+IND_NAME [ Indicator ]; Close_Val = "Close Value = "+DoubleToStr(CenterVal [ Indicator ],2); break;
      case 3: IND_VAL = "Current Value = "+DoubleToStr(DeM(),2); IND = "Indicator = "+IND_NAME [ Indicator ]; Close_Val = "Close Value = "+DoubleToStr(CenterVal [ Indicator ],2); break;
      case 4: IND_VAL = "Current Value = "+DoubleToStr(Bears(),2); IND = "Indicator = "+IND_NAME [ Indicator ]; Close_Val = "Close Value = "+DoubleToStr(CenterVal [ Indicator ],2); break;
      default: break;
   }
   
   string TIMEFRAME = "TimeFrame = "+TF_STRING [ TimeFrame ];
   if(TimeFrame == 0) TIMEFRAME = "TimeFrame = "+TF_STRING [ Period_to_TF( Period() ) ]+" (Chart)";
   
   string IND_PERIOD = "Ind_Period = "+Ind_Period;

   string PRICE = "Price = "+PRICE_STRING [ AppliedPrice ];
   
   string SHIFT = "Bar Shift = 0 (Current Bar)";
   if(BarShift>0) SHIFT = "Bar Shift = "+ BarShift +" (Closed Bar)";
   
   string DayofWeek = DOW [ DayOfWeek() ];
   string MONTH = Month(); if(Month()<10) MONTH = "0"+MONTH;
   string DAY = Day(); if(Day()<10) DAY = "0"+DAY;
   string HOUR = Hour(); if(Hour()<10) HOUR = "0"+HOUR;
   string MIN = Minute(); if(Minute()<10) MIN = "0"+MIN;

   string CurrentTime = Year()+"/"+MONTH+"/"+DAY+"/"+DayofWeek+"/"+HOUR+":"+MIN;

   Comment(DAAAAASH,"\n",EANAME,"\n",
           DAAAAASH,"\n",Enabeled,"\n",IND,"\n", TIMEFRAME,"\n",
           DAAAAASH,"\n",IND_PERIOD,"\n",PRICE,"\n",SHIFT,"\n",
           DAAAAASH,"\n",IND_VAL,"\n",Close_Val,"\n",
           DAAAAASH,"\n",CurrentTime
           );
}

//+------------------------------------------------------------------+
//| Period_to_TF                                                     |
//+------------------------------------------------------------------+
int Period_to_TF(int PERIOD_IN_MINUTE)
{
   int PERIOD_TF;

   // Indicator Time Frame
   switch(PERIOD_IN_MINUTE) // 0=Chart 1=M1 2=M5 3=M15 4=M30 5=1H 6=4H 7=D1 8=W1 9=MN
   {
      case 0 : PERIOD_TF = 0; break; 
      case 1 : PERIOD_TF = 1; break; 
      case 5 : PERIOD_TF = 2; break; 
      case 15 : PERIOD_TF = 3; break; 
      case 30 : PERIOD_TF = 4; break; 
      case 60 : PERIOD_TF = 5; break; 
      case 240 : PERIOD_TF = 6; break; 
      case 1440 : PERIOD_TF = 7; break; 
      case 10080 : PERIOD_TF = 8; break; 
      case 43200 : PERIOD_TF = 9; break; 
      default: break; 
   }

   return(PERIOD_TF);
}